/*####################################################################
  FILE: Test_sensore_GA1A12S202.ino
  VERSION: 2.0
  Descrizione: Programma di prova per sensore analogico di luce tipo GA1A12S202

  Collegare l'uscira del sensore al pin Analog Pin 0
  Collegare il pin 5v to VCC e GND a GND
  Collegare il pin 3.3v al pin AREF
  Collegare il in Digital 2 al LCD

  Creato il 31/05/2014 da Adriano Gandolfo
  Modificato il 01/05/2019 da Adriano Gandolfo
  Sito web https://www.adrirobot.it
  Blog https://it.emcelettronica.com/author/adrirobot
  Pagina Facebook https://www.facebook.com/Adrirobot-318949048122955
  Istagram https://www.instagram.com/adrirobot/
  This example code is in the public domain.
  #######################################################################*/


#include <SoftwareSerial.h>
#define aref_voltage 3.25 // Verificare il valore con un multimetro!
#include <LiquidCrystal_I2C.h>
// Set the LCD address to 0x27 for a 16 chars and 2 line display
LiquidCrystal_I2C lcd(0x27, 16, 2);

int luxSensorPin = A0;
void setup()
{


  analogReference(EXTERNAL); //

  Serial.begin(9600);
  Serial.println("Test sensore analogico di luce Adafruit");
  Serial.println("Tipo GA1A12S202");
  //Inizializzazione display
  lcd.begin(); //Init with pin default ESP8266 or ARDUINO
  lcd.backlight();
}

void loop()
{
  //lettura dati dal sensore
  int U = analogRead(luxSensorPin); //Valore grezzo
  float V = U * aref_voltage; //
  V /= 1024.0;              //Valore in V
  float I = (V / 68000);    //Valore in A
  I = I * 1000000;          //Corrente in uA
  float Ev = pow(10, I / 10); //Valore lux
  //Stampa dati
  Serial.println(" ");
  Serial.print("Valore grezzo : ");
  Serial.println(U);
  Serial.print("Tensione : ");
  Serial.print(V);
  Serial.println(" V");
  Serial.print("Corrente: ");
  Serial.print(I);
  Serial.println(" uA");
  Serial.print("Flusso : ");
  Serial.print(Ev, 1);
  Serial.println(" lx");

  //Scrittura dati su display LCD
  lcd.setCursor(0, 0);
  lcd.print("Luxmetro"); // Scrive messaggio
  lcd.setCursor(0, 1);
  lcd.print("Lux = ");
  lcd.print(Ev, 1);


  //Pausa tre le letture
  delay(1000);
}
